/****************************************************** 
 * File  : execute.h   
 * Desc. : State and action tuple def
 * Author: Rune M. Jensen
 * Date  : 7/17/01
 ******************************************************/

#ifndef EXECUTEH
#define EXECUTEH

#include "main.h"



enum Act {move_right,move_left,move_up,move_down,move_right_up,move_right_down,move_left_up,move_left_down,nop};


struct action {
  Act Hunt;
  Act Prey;
};


struct gridpos {
  int x;
  int y;
};

struct gridstate {
  gridpos h,p;
};

struct screenpos {
  double x;
  double y;
};

struct screenstate {
  screenpos h,p;
};




// prototypes
gridstate execute(DisplayInfo di, gridstate old_st, action act, int speed);
void Simulate(DisplayInfo di,gridstate old_st,gridstate new_st,int speed);
screenpos Grid2ScreenPos(gridpos gp,int sceen_size);
screenpos DeltaScreenPos(gridpos old_p, gridpos new_p, int screen_size);
void Move2GridState(DisplayInfo di,gridstate st);
gridstate initstate(void);
gridstate newinitstate(gridstate res);   
bool goal_reached(gridstate st);

#endif  

