/****************************************************** 
 * File  : execute.h   
 * Desc. : State and action tuple def
 * Author: Rune M. Jensen
 * Date  : 5/7/01
 ******************************************************/

#ifndef EXECUTEH
#define EXECUTEH

#include "main.h"



enum VerAct {VRightOn12,VRightOn1,VRightOn2,VRight,VLeftOn12,VLeftOn1,VLeftOn2,VLeft,VFlip,VNop};
enum HorAct {HUpOn12,HUpOn1,HUpOn2,HUp,HDownOn12,HDownOn1,HDownOn2,HDown,HFlip,HNop};

struct action {
  VerAct Ver;
  HorAct Hor;
};


struct gridpos {
  int x;
  int y;
};

struct gridstate {
  gridpos o1,o2,v,h;
  bool  von;
  bool  hon;
};

struct screenpos {
  double x;
  double y;
};

struct screenstate {
  screenpos o1,o2,v,h;
};




// prototypes
gridstate execute(DisplayInfo di, gridstate old_st, action act, int speed);
void Simulate(DisplayInfo di,gridstate old_st,gridstate new_st,int speed);
screenpos Grid2ScreenPos(gridpos gp,int sceen_size);
screenpos DeltaScreenPos(gridpos old_p, gridpos new_p, int screen_size);
void Move2GridState(DisplayInfo di,gridstate st);
gridstate initstate(void);
gridstate newinitstate(gridstate res);   
bool goal_reached(gridstate st);

#endif  
