/*========================================================================
                              
                                ** UMOP **
		** Universal Multi-Agent OBDD-based Planner **

            Copyright (C) 1999 by Rune M. Jensen and Manuela M. Veloso
            Computer Science Department, Carnegie Mellon University.
            
    Permission is hereby granted to distribute the UMOP software for 
    research purposes, provided this notice is included with any such 
    distribution. 

      *** WE ARE NOT RESPONSIBLE FOR ANY KIND OF DAMAGE TO YOUR  ***
      *** FILES, DATA, HARDWARE, LOSS OF MONEY, SYSTEM CRASHES   *** 
      *** OR ANY OTHER THING YOU MIGHT COME UP WITH.             ***
      *** - USE THIS PROGRAM OF YOUR OWN FREE WILL !!!           ***

========================================================================*/
/****************************************************** 
 File  : set.hpp   
 Desc. : STL string set manipulation functions
         See e.g. "Using the STL, The C++ Standard Template 
         Library" by Robert Robson, sec. edit., Springer, 1999
         for an in depth discussion of these algorithms.
 Author: Rune M. Jensen
 Date  : 10/23/00
 ******************************************************/


#ifndef SETHPP
#define SETHPP

#include "common.hpp"
#include <set>
#include <algorithm>
#include <stream.h>

// set member
template<class T> bool setMember(set<T> &s,T e) {

  if (s.find(e) == s.end() )
    return false;
  else
    return true;
}


// setunion
template<class T> set<T> setUnion(set<T> &s1,set<T> &s2) {
  set<T> res;
  insert_iterator< set<T> > res_ins(res, res.begin());
  set_union(s1.begin(),s1.end(),s2.begin(),s2.end(),res_ins);
  return res;
}

// set intersection
template<class T> set<T> setIntersection(set<T> &s1,set<T> &s2) {
  set<T> res;
  insert_iterator< set<T> > res_ins(res, res.begin());
  set_intersection(s1.begin(),s1.end(),s2.begin(),s2.end(),res_ins);
  return res;
}      

// set difference (s1 - s2)
template<class T> set<T> setDifference(set<T> &s1,set<T> &s2) {
  set<T> res;
  insert_iterator< set<T> > res_ins(res, res.begin());
  set_difference(s1.begin(),s1.end(),s2.begin(),s2.end(),res_ins);
  return res;
}


// set symmetric difference (union - intersection)
template<class T> set<T> setSymmetricDifference(set<T> &s1,set<T> &s2) {
  set<T> res;
  insert_iterator< set<T> > res_ins(res, res.begin());
  set_symmetric_difference(s1.begin(),s1.end(),s2.begin(),s2.end(),res_ins);
  return res;
}



template<class T> void setPrint(set<T> &s) {
  set<T>::iterator i;

  for (i= s.begin(); i != s.end(); ++i)
    cout << *i << " ";
}


#endif
