/*========================================================================
                              
                                ** UMOP **
		** Universal Multi-Agent OBDD-based Planner **

            Copyright (C) 1999 by Rune M. Jensen and Manuela M. Veloso
            Computer Science Department, Carnegie Mellon University.
            
    Permission is hereby granted to distribute the UMOP software for 
    research purposes, provided this notice is included with any such 
    distribution. 

      *** WE ARE NOT RESPONSIBLE FOR ANY KIND OF DAMAGE TO YOUR  ***
      *** FILES, DATA, HARDWARE, LOSS OF MONEY, SYSTEM CRASHES   *** 
      *** OR ANY OTHER THING YOU MIGHT COME UP WITH.             ***
      *** - USE THIS PROGRAM OF YOUR OWN FREE WILL !!!           ***

========================================================================*/
/****************************************************** 
 * File  : time.cc  
 * Desc. : Simple functions for measuring run times, 
 *         runtime must be less than 10 hours.
 *         (see man setitimer for description) 
 * Author: Rune M. Jensen
 * Date  : 5/22/00
 ******************************************************/

#include <sys/time.h>
#include  <stream.h>
#include "timer.hpp"

void resettimers() {
  // resets the decrementing process timer
  // timer must be reset every 10 hours
  struct itimerval reset;
  reset.it_interval.tv_sec = 0;
  reset.it_interval.tv_usec = 0;
  reset.it_value.tv_sec = 10*60*60;
  reset.it_value.tv_usec = 0;
  setitimer(ITIMER_PROF, &reset, NULL);
}


// start a timer
void timer::start() {
    getitimer(ITIMER_PROF, &startt);
}

// stop timer and print result
double timer::stop() {

  struct itimerval stopp;
  double elapsedtime;

  getitimer(ITIMER_PROF, &stopp);
  elapsedtime = startt.it_value.tv_sec - stopp.it_value.tv_sec - 1
  + 1e-6 * (1000000 - stopp.it_value.tv_usec);
  cout << "Elapsed CPU time : " <<  elapsedtime << " seconds \n";

  return elapsedtime;
}
